FROM alpine:3.13
LABEL Maintainer="Donny Rhomanzah <donnyrhomanzah@gmail.com>" \
      Description="Lightweight container with Nginx 1.18 & PHP-FPM 7.3 based on Alpine Linux."

# Update Deps
RUN apk update && \
    apk upgrade

# Install packages and remove default server definition
RUN apk --no-cache add php7  \
    php7-ftp \
    php7-fpm \
    php7-opcache \
    php7-mysqli \
    php7-json \
    php7-openssl \
    php7-curl \
    php7-zlib \
    php7-xml \
    php7-phar \
    php7-intl \
    php7-dom \
    php7-xmlreader \
    php7-ctype \
    php7-session \
    php7-common \
    php7-pgsql \
    php7-imagick \
    php7-dev \
    php7-soap \
    php7-zip \
    php7-imap \
    php7-xmlwriter\
    php7-tokenizer \
    php7-iconv \
    php7-fileinfo \
    php7-simplexml \
    php7-pdo \
    php7-pdo_mysql \
    php7-pdo_pgsql \
    php7-redis \
    php7-mbstring \
    php7-gd \
    nginx \
    supervisor \
    curl \
    unzip \
    libaio-dev \
    g++ \
    gcc \
    make \
    file \
    gcompat \
    libnsl \
    re2c \
    && rm /etc/nginx/conf.d/default.conf

RUN ln -s /usr/lib/libnsl.so.2 /usr/lib/libnsl.so.1
RUN curl -sS https://getcomposer.org/installer | php -- --install-dir=/usr/local/bin --filename=composer
    
# Configure nginx
COPY config/nginx.conf /etc/nginx/nginx.conf

# Configure PHP-FPM
COPY config/fpm-pool.conf /etc/php7/php-fpm.d/www.conf
COPY config/php.ini /etc/php7/conf.d/custom.ini

# Configure supervisord
COPY config/supervisord.conf /etc/supervisor/conf.d/supervisord.conf

# Setup document root
RUN mkdir -p /var/www/html

# Make sure files/folders needed by the processes are accessable when they run under the nobody user
RUN chown -R nobody.nobody /var/www/html && \
  chown -R nobody.nobody /run && \
  chown -R nobody.nobody /var/lib/nginx && \
  chown -R nobody.nobody /var/log/nginx



# Uninstall package
RUN apk del php7-dev

# Switch to use a non-root user from here on
USER nobody

# Add application
WORKDIR /var/www/html
COPY --chown=nobody src/ /var/www/html/

# Expose the port nginx is reachable on
EXPOSE 8080
EXPOSE 8081

# Let supervisord start nginx & php-fpm
CMD ["/usr/bin/supervisord", "-c", "/etc/supervisor/conf.d/supervisord.conf"]

# Configure a healthcheck to validate that everything is up&running
HEALTHCHECK --timeout=10s CMD curl --silent --fail http://127.0.0.1:8080/fpm-ping
